/* Generated By:JJTree&JavaCC: Do not edit this line. JBossQLParserTokenManager.java */
package org.jboss.as.cmp.ejbql;
import java.io.CharArrayReader;
import java.util.ArrayList;
import java.util.List;
import org.jboss.as.cmp.bridge.EntityBridge;
import org.jboss.as.cmp.bridge.CMPFieldBridge;
import org.jboss.as.cmp.bridge.CMRFieldBridge;
import org.jboss.as.cmp.bridge.FieldBridge;

/** Token Manager. */
public class JBossQLParserTokenManager implements JBossQLParserConstants
{
   public Catalog catalog;
   public Class[] argumentTypes;
   public IdentifierManager idManager;

   // used for navigation building
   private List pathList;
   private List fieldList;
   private String path;

   private void resetPath() {
      path = "";
      pathList = new ArrayList();
      fieldList = new ArrayList();
   }

   private void throwUnknownPath(
         String reason,
         String fieldName) {

      throw new UnknownPathException(
            reason,
            path,
            fieldName,
            input_stream.getEndLine(),
            input_stream.getEndColumn());
   }

   private void addPath(String nav) {
      String fieldName = nav.substring(0, nav.length()-1);
      if(fieldList.size() > 0) {
         FieldBridge field = getCurrentSchema().getFieldByName(fieldName);
         if(field == null) {
            throwUnknownPath("Unknown cmr field in path", fieldName);
         }
         if(!(field instanceof CMRFieldBridge)) {
            throwUnknownPath("In path field is not a cmr field", fieldName);
         }

         CMRFieldBridge cmrField = (CMRFieldBridge)field;
         if(!cmrField.isSingleValued()) {
            throwUnknownPath("In path cmr field is collection valued",
                  fieldName);
         }
         fieldList.add(cmrField);
      } else {
         EntityBridge entityBridge = idManager.getEntity(fieldName);
         if(entityBridge == null) {
            throwUnknownPath("Unknown initial identifier", fieldName);
         }
         fieldList.add(entityBridge);
      }
      pathList.add(path + fieldName);
      path += nav;
   }

   private EntityBridge getCurrentSchema() {
      Object lastElement = fieldList.get(fieldList.size()-1);
      if(lastElement instanceof EntityBridge) {
         return (EntityBridge)lastElement;
      } else if(lastElement instanceof CMRFieldBridge) {
         return ((CMRFieldBridge)lastElement).getRelatedEntity();
      }
      // should never happen
      throw new IllegalStateException("Unknown path element type: " +
            lastElement);
   }

  /** Debug output. */
  public  java.io.PrintStream debugStream = System.out;
  /** Set debug output. */
  public  void setDebugStream(java.io.PrintStream ds) { debugStream = ds; }
private int jjMoveStringLiteralDfa0_1()
{
   return jjMoveNfa_1(0, 0);
}
static final long[] jjbitVec0 = {
   0x1ff00000fffffffeL, 0xffffffffffffc000L, 0xffffffffL, 0x600000000000000L
};
static final long[] jjbitVec2 = {
   0x0L, 0x0L, 0x0L, 0xff7fffffff7fffffL
};
static final long[] jjbitVec3 = {
   0x0L, 0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffffffffffffffL
};
static final long[] jjbitVec4 = {
   0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffL, 0x0L
};
static final long[] jjbitVec5 = {
   0xffffffffffffffffL, 0xffffffffffffffffL, 0x0L, 0x0L
};
static final long[] jjbitVec6 = {
   0x3fffffffffffL, 0x0L, 0x0L, 0x0L
};
private int jjMoveNfa_1(int startState, int curPos)
{
   int startsAt = 0;
   jjnewStateCnt = 4;
   int i = 1;
   jjstateSet[0] = startState;
   int kind = 0x7fffffff;
   for (;;)
   {
      if (++jjround == 0x7fffffff)
         ReInitRounds();
      if (curChar < 64)
      {
         long l = 1L << curChar;
         do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if (curChar != 36)
                     break;
                  if (kind > 74)
                     kind = 74;
                  jjCheckNAddStates(0, 2);
                  break;
               case 1:
                  if ((0x3ff001000000000L & l) != 0L)
                     jjCheckNAddTwoStates(1, 2);
                  break;
               case 2:
                  if (curChar == 46)
                     kind = 73;
                  break;
               case 3:
                  if ((0x3ff001000000000L & l) == 0L)
                     break;
                  if (kind > 74)
                     kind = 74;
                  jjCheckNAdd(3);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else if (curChar < 128)
      {
         long l = 1L << (curChar & 077);
         do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if ((0x7fffffe87fffffeL & l) == 0L)
                     break;
                  if (kind > 74)
                     kind = 74;
                  jjCheckNAddStates(0, 2);
                  break;
               case 1:
                  if ((0x7fffffe87fffffeL & l) != 0L)
                     jjCheckNAddTwoStates(1, 2);
                  break;
               case 3:
                  if ((0x7fffffe87fffffeL & l) == 0L)
                     break;
                  if (kind > 74)
                     kind = 74;
                  jjCheckNAdd(3);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else
      {
         int hiByte = (int)(curChar >> 8);
         int i1 = hiByte >> 6;
         long l1 = 1L << (hiByte & 077);
         int i2 = (curChar & 0xff) >> 6;
         long l2 = 1L << (curChar & 077);
         do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 74)
                     kind = 74;
                  jjCheckNAddStates(0, 2);
                  break;
               case 1:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(1, 2);
                  break;
               case 3:
                  if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 74)
                     kind = 74;
                  jjCheckNAdd(3);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      if (kind != 0x7fffffff)
      {
         jjmatchedKind = kind;
         jjmatchedPos = curPos;
         kind = 0x7fffffff;
      }
      ++curPos;
      if ((i = jjnewStateCnt) == (startsAt = 4 - (jjnewStateCnt = startsAt)))
         return curPos;
      try { curChar = input_stream.readChar(); }
      catch(java.io.IOException e) { return curPos; }
   }
}
private int jjStopAtPos(int pos, int kind)
{
   jjmatchedKind = kind;
   jjmatchedPos = pos;
   return pos + 1;
}
private int jjMoveStringLiteralDfa0_0()
{
   switch(curChar)
   {
      case 9:
         jjmatchedKind = 2;
         return jjMoveNfa_0(0, 0);
      case 10:
         jjmatchedKind = 3;
         return jjMoveNfa_0(0, 0);
      case 13:
         jjmatchedKind = 4;
         return jjMoveNfa_0(0, 0);
      case 32:
         jjmatchedKind = 1;
         return jjMoveNfa_0(0, 0);
      case 40:
         jjmatchedKind = 44;
         return jjMoveNfa_0(0, 0);
      case 41:
         jjmatchedKind = 45;
         return jjMoveNfa_0(0, 0);
      case 42:
         jjmatchedKind = 56;
         return jjMoveNfa_0(0, 0);
      case 43:
         jjmatchedKind = 54;
         return jjMoveNfa_0(0, 0);
      case 44:
         jjmatchedKind = 46;
         return jjMoveNfa_0(0, 0);
      case 45:
         jjmatchedKind = 55;
         return jjMoveNfa_0(0, 0);
      case 46:
         jjmatchedKind = 47;
         return jjMoveNfa_0(0, 0);
      case 47:
         jjmatchedKind = 57;
         return jjMoveNfa_0(0, 0);
      case 60:
         jjmatchedKind = 49;
         return jjMoveStringLiteralDfa1_0(0x28000000000000L, 0x0L);
      case 61:
         jjmatchedKind = 50;
         return jjMoveNfa_0(0, 0);
      case 62:
         jjmatchedKind = 48;
         return jjMoveStringLiteralDfa1_0(0x10000000000000L, 0x0L);
      case 65:
         return jjMoveStringLiteralDfa1_0(0x8000020e0L, 0x0L);
      case 66:
         return jjMoveStringLiteralDfa1_0(0x20000000100L, 0x0L);
      case 67:
         return jjMoveStringLiteralDfa1_0(0x600L, 0x0L);
      case 68:
         return jjMoveStringLiteralDfa1_0(0x1000008000L, 0x0L);
      case 69:
         return jjMoveStringLiteralDfa1_0(0x30000L, 0x0L);
      case 70:
         return jjMoveStringLiteralDfa1_0(0x40000L, 0x2L);
      case 73:
         return jjMoveStringLiteralDfa1_0(0x180000L, 0x0L);
      case 76:
         return jjMoveStringLiteralDfa1_0(0x6000e00000L, 0x0L);
      case 77:
         return jjMoveStringLiteralDfa1_0(0x80400001800L, 0x0L);
      case 78:
         return jjMoveStringLiteralDfa1_0(0x3000000L, 0x0L);
      case 79:
         return jjMoveStringLiteralDfa1_0(0x1801c000000L, 0x0L);
      case 83:
         return jjMoveStringLiteralDfa1_0(0xe0004000L, 0x0L);
      case 84:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x4L);
      case 85:
         return jjMoveStringLiteralDfa1_0(0x40100000000L, 0x0L);
      case 87:
         return jjMoveStringLiteralDfa1_0(0x200000000L, 0x0L);
      case 97:
         return jjMoveStringLiteralDfa1_0(0x8000020e0L, 0x0L);
      case 98:
         return jjMoveStringLiteralDfa1_0(0x20000000100L, 0x0L);
      case 99:
         return jjMoveStringLiteralDfa1_0(0x600L, 0x0L);
      case 100:
         return jjMoveStringLiteralDfa1_0(0x1000008000L, 0x0L);
      case 101:
         return jjMoveStringLiteralDfa1_0(0x30000L, 0x0L);
      case 102:
         return jjMoveStringLiteralDfa1_0(0x40000L, 0x2L);
      case 105:
         return jjMoveStringLiteralDfa1_0(0x180000L, 0x0L);
      case 108:
         return jjMoveStringLiteralDfa1_0(0x6000e00000L, 0x0L);
      case 109:
         return jjMoveStringLiteralDfa1_0(0x80400001800L, 0x0L);
      case 110:
         return jjMoveStringLiteralDfa1_0(0x3000000L, 0x0L);
      case 111:
         return jjMoveStringLiteralDfa1_0(0x1801c000000L, 0x0L);
      case 115:
         return jjMoveStringLiteralDfa1_0(0xe0004000L, 0x0L);
      case 116:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x4L);
      case 117:
         return jjMoveStringLiteralDfa1_0(0x40100000000L, 0x0L);
      case 119:
         return jjMoveStringLiteralDfa1_0(0x200000000L, 0x0L);
      default :
         return jjMoveNfa_0(0, 0);
   }
}
private int jjMoveStringLiteralDfa1_0(long active0, long active1)
{
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
   return jjMoveNfa_0(0, 0);
   }
   switch(curChar)
   {
      case 61:
         if ((active0 & 0x8000000000000L) != 0L)
         {
            jjmatchedKind = 51;
            jjmatchedPos = 1;
         }
         else if ((active0 & 0x10000000000000L) != 0L)
         {
            jjmatchedKind = 52;
            jjmatchedPos = 1;
         }
         break;
      case 62:
         if ((active0 & 0x20000000000000L) != 0L)
         {
            jjmatchedKind = 53;
            jjmatchedPos = 1;
         }
         break;
      case 65:
         return jjMoveStringLiteralDfa2_0(active0, 0x800L, active1, 0x2L);
      case 66:
         return jjMoveStringLiteralDfa2_0(active0, 0x4000020L, active1, 0L);
      case 67:
         return jjMoveStringLiteralDfa2_0(active0, 0x42000000000L, active1, 0L);
      case 69:
         return jjMoveStringLiteralDfa2_0(active0, 0x1420200100L, active1, 0L);
      case 70:
         return jjMoveStringLiteralDfa2_0(active0, 0x8008000000L, active1, 0L);
      case 72:
         return jjMoveStringLiteralDfa2_0(active0, 0x200000000L, active1, 0L);
      case 73:
         return jjMoveStringLiteralDfa2_0(active0, 0x4000409000L, active1, 0L);
      case 77:
         return jjMoveStringLiteralDfa2_0(active0, 0x10000L, active1, 0L);
      case 78:
         if ((active0 & 0x80000L) != 0L)
         {
            jjmatchedKind = 19;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0x100000040L, active1, 0L);
      case 79:
         return jjMoveStringLiteralDfa2_0(active0, 0x80001800600L, active1, 0L);
      case 81:
         return jjMoveStringLiteralDfa2_0(active0, 0x80000000L, active1, 0L);
      case 82:
         if ((active0 & 0x10000000L) != 0L)
         {
            jjmatchedKind = 28;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0x10000040000L, active1, 0x4L);
      case 83:
         if ((active0 & 0x80L) != 0L)
         {
            jjmatchedKind = 7;
            jjmatchedPos = 1;
         }
         else if ((active0 & 0x100000L) != 0L)
         {
            jjmatchedKind = 20;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0x800020000L, active1, 0L);
      case 85:
         return jjMoveStringLiteralDfa2_0(active0, 0x42004000L, active1, 0L);
      case 86:
         return jjMoveStringLiteralDfa2_0(active0, 0x2000L, active1, 0L);
      case 89:
         if ((active0 & 0x20000000000L) != 0L)
         {
            jjmatchedKind = 41;
            jjmatchedPos = 1;
         }
         break;
      case 97:
         return jjMoveStringLiteralDfa2_0(active0, 0x800L, active1, 0x2L);
      case 98:
         return jjMoveStringLiteralDfa2_0(active0, 0x4000020L, active1, 0L);
      case 99:
         return jjMoveStringLiteralDfa2_0(active0, 0x42000000000L, active1, 0L);
      case 101:
         return jjMoveStringLiteralDfa2_0(active0, 0x1420200100L, active1, 0L);
      case 102:
         return jjMoveStringLiteralDfa2_0(active0, 0x8008000000L, active1, 0L);
      case 104:
         return jjMoveStringLiteralDfa2_0(active0, 0x200000000L, active1, 0L);
      case 105:
         return jjMoveStringLiteralDfa2_0(active0, 0x4000409000L, active1, 0L);
      case 109:
         return jjMoveStringLiteralDfa2_0(active0, 0x10000L, active1, 0L);
      case 110:
         if ((active0 & 0x80000L) != 0L)
         {
            jjmatchedKind = 19;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0x100000040L, active1, 0L);
      case 111:
         return jjMoveStringLiteralDfa2_0(active0, 0x80001800600L, active1, 0L);
      case 113:
         return jjMoveStringLiteralDfa2_0(active0, 0x80000000L, active1, 0L);
      case 114:
         if ((active0 & 0x10000000L) != 0L)
         {
            jjmatchedKind = 28;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0x10000040000L, active1, 0x4L);
      case 115:
         if ((active0 & 0x80L) != 0L)
         {
            jjmatchedKind = 7;
            jjmatchedPos = 1;
         }
         else if ((active0 & 0x100000L) != 0L)
         {
            jjmatchedKind = 20;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0x800020000L, active1, 0L);
      case 117:
         return jjMoveStringLiteralDfa2_0(active0, 0x42004000L, active1, 0L);
      case 118:
         return jjMoveStringLiteralDfa2_0(active0, 0x2000L, active1, 0L);
      case 121:
         if ((active0 & 0x20000000000L) != 0L)
         {
            jjmatchedKind = 41;
            jjmatchedPos = 1;
         }
         break;
      default :
         break;
   }
   return jjMoveNfa_0(0, 1);
}
private int jjMoveStringLiteralDfa2_0(long old0, long active0, long old1, long active1)
{
   if (((active0 &= old0) | (active1 &= old1)) == 0L)
      return jjMoveNfa_0(0, 1);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
   return jjMoveNfa_0(0, 1);
   }
   switch(curChar)
   {
      case 32:
         if ((active0 & 0x8000000L) != 0L)
         {
            jjmatchedKind = 27;
            jjmatchedPos = 2;
         }
         break;
      case 65:
         return jjMoveStringLiteralDfa3_0(active0, 0x42000000000L, active1, 0L);
      case 66:
         return jjMoveStringLiteralDfa3_0(active0, 0x40000000L, active1, 0L);
      case 67:
         if ((active0 & 0x800000000L) != 0L)
         {
            jjmatchedKind = 35;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x820000L, active1, 0L);
      case 68:
         if ((active0 & 0x40L) != 0L)
         {
            jjmatchedKind = 6;
            jjmatchedPos = 2;
         }
         else if ((active0 & 0x80000000000L) != 0L)
         {
            jjmatchedKind = 43;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x10000000000L, active1, 0L);
      case 69:
         return jjMoveStringLiteralDfa3_0(active0, 0x200000000L, active1, 0L);
      case 70:
         return jjMoveStringLiteralDfa3_0(active0, 0x8000000000L, active1, 0L);
      case 71:
         if ((active0 & 0x2000L) != 0L)
         {
            jjmatchedKind = 13;
            jjmatchedPos = 2;
         }
         break;
      case 74:
         return jjMoveStringLiteralDfa3_0(active0, 0x4000000L, active1, 0L);
      case 75:
         return jjMoveStringLiteralDfa3_0(active0, 0x100400000L, active1, 0L);
      case 76:
         return jjMoveStringLiteralDfa3_0(active0, 0x22000000L, active1, 0x2L);
      case 77:
         if ((active0 & 0x4000L) != 0L)
         {
            jjmatchedKind = 14;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x4400000000L, active1, 0L);
      case 78:
         if ((active0 & 0x1000L) != 0L)
         {
            jjmatchedKind = 12;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x200200L, active1, 0L);
      case 79:
         return jjMoveStringLiteralDfa3_0(active0, 0x40000L, active1, 0L);
      case 80:
         return jjMoveStringLiteralDfa3_0(active0, 0x10000L, active1, 0L);
      case 82:
         return jjMoveStringLiteralDfa3_0(active0, 0x80000000L, active1, 0L);
      case 83:
         if ((active0 & 0x20L) != 0L)
         {
            jjmatchedKind = 5;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x1000008000L, active1, 0L);
      case 84:
         if ((active0 & 0x1000000L) != 0L)
         {
            jjmatchedKind = 24;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x100L, active1, 0L);
      case 85:
         return jjMoveStringLiteralDfa3_0(active0, 0x400L, active1, 0x4L);
      case 88:
         if ((active0 & 0x800L) != 0L)
         {
            jjmatchedKind = 11;
            jjmatchedPos = 2;
         }
         break;
      case 97:
         return jjMoveStringLiteralDfa3_0(active0, 0x42000000000L, active1, 0L);
      case 98:
         return jjMoveStringLiteralDfa3_0(active0, 0x40000000L, active1, 0L);
      case 99:
         if ((active0 & 0x800000000L) != 0L)
         {
            jjmatchedKind = 35;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x820000L, active1, 0L);
      case 100:
         if ((active0 & 0x40L) != 0L)
         {
            jjmatchedKind = 6;
            jjmatchedPos = 2;
         }
         else if ((active0 & 0x80000000000L) != 0L)
         {
            jjmatchedKind = 43;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x10000000000L, active1, 0L);
      case 101:
         return jjMoveStringLiteralDfa3_0(active0, 0x200000000L, active1, 0L);
      case 102:
         return jjMoveStringLiteralDfa3_0(active0, 0x8000000000L, active1, 0L);
      case 103:
         if ((active0 & 0x2000L) != 0L)
         {
            jjmatchedKind = 13;
            jjmatchedPos = 2;
         }
         break;
      case 106:
         return jjMoveStringLiteralDfa3_0(active0, 0x4000000L, active1, 0L);
      case 107:
         return jjMoveStringLiteralDfa3_0(active0, 0x100400000L, active1, 0L);
      case 108:
         return jjMoveStringLiteralDfa3_0(active0, 0x22000000L, active1, 0x2L);
      case 109:
         if ((active0 & 0x4000L) != 0L)
         {
            jjmatchedKind = 14;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x4400000000L, active1, 0L);
      case 110:
         if ((active0 & 0x1000L) != 0L)
         {
            jjmatchedKind = 12;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x200200L, active1, 0L);
      case 111:
         return jjMoveStringLiteralDfa3_0(active0, 0x40000L, active1, 0L);
      case 112:
         return jjMoveStringLiteralDfa3_0(active0, 0x10000L, active1, 0L);
      case 114:
         return jjMoveStringLiteralDfa3_0(active0, 0x80000000L, active1, 0L);
      case 115:
         if ((active0 & 0x20L) != 0L)
         {
            jjmatchedKind = 5;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x1000008000L, active1, 0L);
      case 116:
         if ((active0 & 0x1000000L) != 0L)
         {
            jjmatchedKind = 24;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x100L, active1, 0L);
      case 117:
         return jjMoveStringLiteralDfa3_0(active0, 0x400L, active1, 0x4L);
      case 120:
         if ((active0 & 0x800L) != 0L)
         {
            jjmatchedKind = 11;
            jjmatchedPos = 2;
         }
         break;
      default :
         break;
   }
   return jjMoveNfa_0(0, 2);
}
private int jjMoveStringLiteralDfa3_0(long old0, long active0, long old1, long active1)
{
   if (((active0 &= old0) | (active1 &= old1)) == 0L)
      return jjMoveNfa_0(0, 2);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
   return jjMoveNfa_0(0, 2);
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa4_0(active0, 0x820000L, active1, 0L);
      case 66:
         return jjMoveStringLiteralDfa4_0(active0, 0x400000000L, active1, 0L);
      case 67:
         if ((active0 & 0x1000000000L) != 0L)
         {
            jjmatchedKind = 36;
            jjmatchedPos = 3;
         }
         return jjMoveStringLiteralDfa4_0(active0, 0x200L, active1, 0L);
      case 69:
         if ((active0 & 0x400000L) != 0L)
         {
            jjmatchedKind = 22;
            jjmatchedPos = 3;
         }
         else if ((active1 & 0x4L) != 0L)
         {
            jjmatchedKind = 66;
            jjmatchedPos = 3;
         }
         return jjMoveStringLiteralDfa4_0(active0, 0x10024000000L, active1, 0L);
      case 71:
         return jjMoveStringLiteralDfa4_0(active0, 0x200000L, active1, 0L);
      case 73:
         return jjMoveStringLiteralDfa4_0(active0, 0x4000000000L, active1, 0L);
      case 76:
         if ((active0 & 0x2000000L) != 0L)
         {
            jjmatchedKind = 25;
            jjmatchedPos = 3;
         }
         break;
      case 77:
         if ((active0 & 0x40000L) != 0L)
         {
            jjmatchedKind = 18;
            jjmatchedPos = 3;
         }
         break;
      case 78:
         return jjMoveStringLiteralDfa4_0(active0, 0x100000400L, active1, 0L);
      case 82:
         return jjMoveStringLiteralDfa4_0(active0, 0x200000000L, active1, 0L);
      case 83:
         return jjMoveStringLiteralDfa4_0(active0, 0x4a040000000L, active1, 0x2L);
      case 84:
         if ((active0 & 0x80000000L) != 0L)
         {
            jjmatchedKind = 31;
            jjmatchedPos = 3;
         }
         return jjMoveStringLiteralDfa4_0(active0, 0x18000L, active1, 0L);
      case 87:
         return jjMoveStringLiteralDfa4_0(active0, 0x100L, active1, 0L);
      case 97:
         return jjMoveStringLiteralDfa4_0(active0, 0x820000L, active1, 0L);
      case 98:
         return jjMoveStringLiteralDfa4_0(active0, 0x400000000L, active1, 0L);
      case 99:
         if ((active0 & 0x1000000000L) != 0L)
         {
            jjmatchedKind = 36;
            jjmatchedPos = 3;
         }
         return jjMoveStringLiteralDfa4_0(active0, 0x200L, active1, 0L);
      case 101:
         if ((active0 & 0x400000L) != 0L)
         {
            jjmatchedKind = 22;
            jjmatchedPos = 3;
         }
         else if ((active1 & 0x4L) != 0L)
         {
            jjmatchedKind = 66;
            jjmatchedPos = 3;
         }
         return jjMoveStringLiteralDfa4_0(active0, 0x10024000000L, active1, 0L);
      case 103:
         return jjMoveStringLiteralDfa4_0(active0, 0x200000L, active1, 0L);
      case 105:
         return jjMoveStringLiteralDfa4_0(active0, 0x4000000000L, active1, 0L);
      case 108:
         if ((active0 & 0x2000000L) != 0L)
         {
            jjmatchedKind = 25;
            jjmatchedPos = 3;
         }
         break;
      case 109:
         if ((active0 & 0x40000L) != 0L)
         {
            jjmatchedKind = 18;
            jjmatchedPos = 3;
         }
         break;
      case 110:
         return jjMoveStringLiteralDfa4_0(active0, 0x100000400L, active1, 0L);
      case 114:
         return jjMoveStringLiteralDfa4_0(active0, 0x200000000L, active1, 0L);
      case 115:
         return jjMoveStringLiteralDfa4_0(active0, 0x4a040000000L, active1, 0x2L);
      case 116:
         if ((active0 & 0x80000000L) != 0L)
         {
            jjmatchedKind = 31;
            jjmatchedPos = 3;
         }
         return jjMoveStringLiteralDfa4_0(active0, 0x18000L, active1, 0L);
      case 119:
         return jjMoveStringLiteralDfa4_0(active0, 0x100L, active1, 0L);
      default :
         break;
   }
   return jjMoveNfa_0(0, 3);
}
private int jjMoveStringLiteralDfa4_0(long old0, long active0, long old1, long active1)
{
   if (((active0 &= old0) | (active1 &= old1)) == 0L)
      return jjMoveNfa_0(0, 3);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
   return jjMoveNfa_0(0, 3);
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa5_0(active0, 0x200L, active1, 0L);
      case 67:
         return jjMoveStringLiteralDfa5_0(active0, 0x24000000L, active1, 0L);
      case 69:
         if ((active0 & 0x200000000L) != 0L)
         {
            jjmatchedKind = 33;
            jjmatchedPos = 4;
         }
         else if ((active0 & 0x2000000000L) != 0L)
         {
            jjmatchedKind = 37;
            jjmatchedPos = 4;
         }
         else if ((active0 & 0x40000000000L) != 0L)
         {
            jjmatchedKind = 42;
            jjmatchedPos = 4;
         }
         else if ((active1 & 0x2L) != 0L)
         {
            jjmatchedKind = 65;
            jjmatchedPos = 4;
         }
         return jjMoveStringLiteralDfa5_0(active0, 0x8400000100L, active1, 0L);
      case 73:
         return jjMoveStringLiteralDfa5_0(active0, 0x8000L, active1, 0L);
      case 79:
         return jjMoveStringLiteralDfa5_0(active0, 0x100000000L, active1, 0L);
      case 80:
         return jjMoveStringLiteralDfa5_0(active0, 0x20000L, active1, 0L);
      case 82:
         if ((active0 & 0x10000000000L) != 0L)
         {
            jjmatchedKind = 40;
            jjmatchedPos = 4;
         }
         break;
      case 84:
         if ((active0 & 0x400L) != 0L)
         {
            jjmatchedKind = 10;
            jjmatchedPos = 4;
         }
         else if ((active0 & 0x4000000000L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 4;
         }
         return jjMoveStringLiteralDfa5_0(active0, 0x40a00000L, active1, 0L);
      case 89:
         if ((active0 & 0x10000L) != 0L)
         {
            jjmatchedKind = 16;
            jjmatchedPos = 4;
         }
         break;
      case 97:
         return jjMoveStringLiteralDfa5_0(active0, 0x200L, active1, 0L);
      case 99:
         return jjMoveStringLiteralDfa5_0(active0, 0x24000000L, active1, 0L);
      case 101:
         if ((active0 & 0x200000000L) != 0L)
         {
            jjmatchedKind = 33;
            jjmatchedPos = 4;
         }
         else if ((active0 & 0x2000000000L) != 0L)
         {
            jjmatchedKind = 37;
            jjmatchedPos = 4;
         }
         else if ((active0 & 0x40000000000L) != 0L)
         {
            jjmatchedKind = 42;
            jjmatchedPos = 4;
         }
         else if ((active1 & 0x2L) != 0L)
         {
            jjmatchedKind = 65;
            jjmatchedPos = 4;
         }
         return jjMoveStringLiteralDfa5_0(active0, 0x8400000100L, active1, 0L);
      case 105:
         return jjMoveStringLiteralDfa5_0(active0, 0x8000L, active1, 0L);
      case 111:
         return jjMoveStringLiteralDfa5_0(active0, 0x100000000L, active1, 0L);
      case 112:
         return jjMoveStringLiteralDfa5_0(active0, 0x20000L, active1, 0L);
      case 114:
         if ((active0 & 0x10000000000L) != 0L)
         {
            jjmatchedKind = 40;
            jjmatchedPos = 4;
         }
         break;
      case 116:
         if ((active0 & 0x400L) != 0L)
         {
            jjmatchedKind = 10;
            jjmatchedPos = 4;
         }
         else if ((active0 & 0x4000000000L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 4;
         }
         return jjMoveStringLiteralDfa5_0(active0, 0x40a00000L, active1, 0L);
      case 121:
         if ((active0 & 0x10000L) != 0L)
         {
            jjmatchedKind = 16;
            jjmatchedPos = 4;
         }
         break;
      default :
         break;
   }
   return jjMoveNfa_0(0, 4);
}
private int jjMoveStringLiteralDfa5_0(long old0, long active0, long old1, long active1)
{
   if (((active0 &= old0) | (active1 &= old1)) == 0L)
      return jjMoveNfa_0(0, 4);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
   return jjMoveNfa_0(0, 4);
   }
   switch(curChar)
   {
      case 69:
         if ((active0 & 0x20000L) != 0L)
         {
            jjmatchedKind = 17;
            jjmatchedPos = 5;
         }
         else if ((active0 & 0x800000L) != 0L)
         {
            jjmatchedKind = 23;
            jjmatchedPos = 5;
         }
         return jjMoveStringLiteralDfa6_0(active0, 0x100L);
      case 72:
         if ((active0 & 0x200000L) != 0L)
         {
            jjmatchedKind = 21;
            jjmatchedPos = 5;
         }
         break;
      case 78:
         return jjMoveStringLiteralDfa6_0(active0, 0x8000L);
      case 82:
         if ((active0 & 0x400000000L) != 0L)
         {
            jjmatchedKind = 34;
            jjmatchedPos = 5;
         }
         return jjMoveStringLiteralDfa6_0(active0, 0x40000000L);
      case 84:
         if ((active0 & 0x200L) != 0L)
         {
            jjmatchedKind = 9;
            jjmatchedPos = 5;
         }
         else if ((active0 & 0x4000000L) != 0L)
         {
            jjmatchedKind = 26;
            jjmatchedPos = 5;
         }
         else if ((active0 & 0x20000000L) != 0L)
         {
            jjmatchedKind = 29;
            jjmatchedPos = 5;
         }
         else if ((active0 & 0x8000000000L) != 0L)
         {
            jjmatchedKind = 39;
            jjmatchedPos = 5;
         }
         break;
      case 87:
         return jjMoveStringLiteralDfa6_0(active0, 0x100000000L);
      case 101:
         if ((active0 & 0x20000L) != 0L)
         {
            jjmatchedKind = 17;
            jjmatchedPos = 5;
         }
         else if ((active0 & 0x800000L) != 0L)
         {
            jjmatchedKind = 23;
            jjmatchedPos = 5;
         }
         return jjMoveStringLiteralDfa6_0(active0, 0x100L);
      case 104:
         if ((active0 & 0x200000L) != 0L)
         {
            jjmatchedKind = 21;
            jjmatchedPos = 5;
         }
         break;
      case 110:
         return jjMoveStringLiteralDfa6_0(active0, 0x8000L);
      case 114:
         if ((active0 & 0x400000000L) != 0L)
         {
            jjmatchedKind = 34;
            jjmatchedPos = 5;
         }
         return jjMoveStringLiteralDfa6_0(active0, 0x40000000L);
      case 116:
         if ((active0 & 0x200L) != 0L)
         {
            jjmatchedKind = 9;
            jjmatchedPos = 5;
         }
         else if ((active0 & 0x4000000L) != 0L)
         {
            jjmatchedKind = 26;
            jjmatchedPos = 5;
         }
         else if ((active0 & 0x20000000L) != 0L)
         {
            jjmatchedKind = 29;
            jjmatchedPos = 5;
         }
         else if ((active0 & 0x8000000000L) != 0L)
         {
            jjmatchedKind = 39;
            jjmatchedPos = 5;
         }
         break;
      case 119:
         return jjMoveStringLiteralDfa6_0(active0, 0x100000000L);
      default :
         break;
   }
   return jjMoveNfa_0(0, 5);
}
private int jjMoveStringLiteralDfa6_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjMoveNfa_0(0, 5);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
   return jjMoveNfa_0(0, 5);
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa7_0(active0, 0x8000L);
      case 73:
         return jjMoveStringLiteralDfa7_0(active0, 0x40000000L);
      case 78:
         if ((active0 & 0x100L) != 0L)
         {
            jjmatchedKind = 8;
            jjmatchedPos = 6;
         }
         else if ((active0 & 0x100000000L) != 0L)
         {
            jjmatchedKind = 32;
            jjmatchedPos = 6;
         }
         break;
      case 99:
         return jjMoveStringLiteralDfa7_0(active0, 0x8000L);
      case 105:
         return jjMoveStringLiteralDfa7_0(active0, 0x40000000L);
      case 110:
         if ((active0 & 0x100L) != 0L)
         {
            jjmatchedKind = 8;
            jjmatchedPos = 6;
         }
         else if ((active0 & 0x100000000L) != 0L)
         {
            jjmatchedKind = 32;
            jjmatchedPos = 6;
         }
         break;
      default :
         break;
   }
   return jjMoveNfa_0(0, 6);
}
private int jjMoveStringLiteralDfa7_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjMoveNfa_0(0, 6);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
   return jjMoveNfa_0(0, 6);
   }
   switch(curChar)
   {
      case 78:
         return jjMoveStringLiteralDfa8_0(active0, 0x40000000L);
      case 84:
         if ((active0 & 0x8000L) != 0L)
         {
            jjmatchedKind = 15;
            jjmatchedPos = 7;
         }
         break;
      case 110:
         return jjMoveStringLiteralDfa8_0(active0, 0x40000000L);
      case 116:
         if ((active0 & 0x8000L) != 0L)
         {
            jjmatchedKind = 15;
            jjmatchedPos = 7;
         }
         break;
      default :
         break;
   }
   return jjMoveNfa_0(0, 7);
}
private int jjMoveStringLiteralDfa8_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjMoveNfa_0(0, 7);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
   return jjMoveNfa_0(0, 7);
   }
   switch(curChar)
   {
      case 71:
         if ((active0 & 0x40000000L) != 0L)
         {
            jjmatchedKind = 30;
            jjmatchedPos = 8;
         }
         break;
      case 103:
         if ((active0 & 0x40000000L) != 0L)
         {
            jjmatchedKind = 30;
            jjmatchedPos = 8;
         }
         break;
      default :
         break;
   }
   return jjMoveNfa_0(0, 8);
}
static final long[] jjbitVec7 = {
   0xfffffffffffffffeL, 0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffffffffffffffL
};
static final long[] jjbitVec8 = {
   0x0L, 0x0L, 0xffffffffffffffffL, 0xffffffffffffffffL
};
private int jjMoveNfa_0(int startState, int curPos)
{
   int strKind = jjmatchedKind;
   int strPos = jjmatchedPos;
   int seenUpto;
   input_stream.backup(seenUpto = curPos + 1);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) { throw new Error("Internal Error"); }
   curPos = 0;
   int startsAt = 0;
   jjnewStateCnt = 46;
   int i = 1;
   jjstateSet[0] = startState;
   int kind = 0x7fffffff;
   for (;;)
   {
      if (++jjround == 0x7fffffff)
         ReInitRounds();
      if (curChar < 64)
      {
         long l = 1L << curChar;
         do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(3, 9);
                  else if (curChar == 36)
                  {
                     if (kind > 67)
                        kind = 67;
                     jjCheckNAddStates(10, 12);
                  }
                  else if (curChar == 46)
                     jjCheckNAdd(10);
                  else if (curChar == 39)
                     jjCheckNAddStates(13, 15);
                  else if (curChar == 63)
                     jjAddStates(16, 17);
                  if ((0x3fe000000000000L & l) != 0L)
                  {
                     if (kind > 59)
                        kind = 59;
                     jjCheckNAddTwoStates(7, 8);
                  }
                  else if (curChar == 48)
                  {
                     if (kind > 59)
                        kind = 59;
                     jjCheckNAddStates(18, 20);
                  }
                  break;
               case 1:
                  if ((0xffffff7fffffffffL & l) != 0L)
                     jjCheckNAddStates(13, 15);
                  break;
               case 2:
                  if (curChar == 39)
                     jjCheckNAddStates(21, 23);
                  break;
               case 3:
                  if (curChar == 39)
                     jjstateSet[jjnewStateCnt++] = 2;
                  break;
               case 4:
                  if ((0xffffff7fffffffffL & l) != 0L)
                     jjCheckNAddStates(21, 23);
                  break;
               case 5:
                  if (curChar == 39 && kind > 58)
                     kind = 58;
                  break;
               case 6:
                  if ((0x3fe000000000000L & l) == 0L)
                     break;
                  if (kind > 59)
                     kind = 59;
                  jjCheckNAddTwoStates(7, 8);
                  break;
               case 7:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 59)
                     kind = 59;
                  jjCheckNAddTwoStates(7, 8);
                  break;
               case 9:
                  if (curChar == 46)
                     jjCheckNAdd(10);
                  break;
               case 10:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 63)
                     kind = 63;
                  jjCheckNAddStates(24, 26);
                  break;
               case 12:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(13);
                  break;
               case 13:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 63)
                     kind = 63;
                  jjCheckNAddTwoStates(13, 14);
                  break;
               case 15:
                  if (curChar == 63)
                     jjAddStates(16, 17);
                  break;
               case 16:
                  if ((0x3fe000000000000L & l) == 0L)
                     break;
                  if (kind > 71)
                     kind = 71;
                  jjCheckNAddTwoStates(17, 18);
                  break;
               case 17:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 71)
                     kind = 71;
                  jjCheckNAddTwoStates(17, 18);
                  break;
               case 19:
                  if (curChar != 48)
                     break;
                  if (kind > 71)
                     kind = 71;
                  jjCheckNAddStates(27, 29);
                  break;
               case 21:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 71)
                     kind = 71;
                  jjCheckNAddTwoStates(21, 18);
                  break;
               case 22:
                  if ((0xff000000000000L & l) == 0L)
                     break;
                  if (kind > 71)
                     kind = 71;
                  jjCheckNAddTwoStates(22, 18);
                  break;
               case 23:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(3, 9);
                  break;
               case 24:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(24, 25);
                  break;
               case 25:
                  if (curChar != 46)
                     break;
                  if (kind > 63)
                     kind = 63;
                  jjCheckNAddStates(30, 32);
                  break;
               case 26:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 63)
                     kind = 63;
                  jjCheckNAddStates(30, 32);
                  break;
               case 28:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(29);
                  break;
               case 29:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 63)
                     kind = 63;
                  jjCheckNAddTwoStates(29, 14);
                  break;
               case 30:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(30, 31);
                  break;
               case 32:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(33);
                  break;
               case 33:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 63)
                     kind = 63;
                  jjCheckNAddTwoStates(33, 14);
                  break;
               case 34:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(33, 35);
                  break;
               case 36:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(37);
                  break;
               case 37:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(37, 14);
                  break;
               case 38:
                  if (curChar != 48)
                     break;
                  if (kind > 59)
                     kind = 59;
                  jjCheckNAddStates(18, 20);
                  break;
               case 40:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 59)
                     kind = 59;
                  jjCheckNAddTwoStates(40, 8);
                  break;
               case 41:
                  if ((0xff000000000000L & l) == 0L)
                     break;
                  if (kind > 59)
                     kind = 59;
                  jjCheckNAddTwoStates(41, 8);
                  break;
               case 42:
                  if (curChar != 36)
                     break;
                  if (kind > 67)
                     kind = 67;
                  jjCheckNAddStates(10, 12);
                  break;
               case 43:
                  if ((0x3ff001000000000L & l) == 0L)
                     break;
                  if (kind > 67)
                     kind = 67;
                  jjCheckNAdd(43);
                  break;
               case 44:
                  if ((0x3ff001000000000L & l) != 0L)
                     jjCheckNAddTwoStates(44, 45);
                  break;
               case 45:
                  if (curChar == 46 && kind > 72)
                     kind = 72;
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else if (curChar < 128)
      {
         long l = 1L << (curChar & 077);
         do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if ((0x7fffffe87fffffeL & l) == 0L)
                     break;
                  if (kind > 67)
                     kind = 67;
                  jjCheckNAddStates(10, 12);
                  break;
               case 1:
                  jjCheckNAddStates(13, 15);
                  break;
               case 4:
                  jjCheckNAddStates(21, 23);
                  break;
               case 8:
                  if ((0x100000001000L & l) != 0L && kind > 59)
                     kind = 59;
                  break;
               case 11:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(36, 37);
                  break;
               case 14:
                  if ((0x5000000050L & l) != 0L && kind > 63)
                     kind = 63;
                  break;
               case 18:
                  if ((0x100000001000L & l) != 0L && kind > 71)
                     kind = 71;
                  break;
               case 20:
                  if ((0x100000001000000L & l) != 0L)
                     jjCheckNAdd(21);
                  break;
               case 21:
                  if ((0x7e0000007eL & l) == 0L)
                     break;
                  if (kind > 71)
                     kind = 71;
                  jjCheckNAddTwoStates(21, 18);
                  break;
               case 27:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(38, 39);
                  break;
               case 31:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(40, 41);
                  break;
               case 35:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(42, 43);
                  break;
               case 39:
                  if ((0x100000001000000L & l) != 0L)
                     jjCheckNAdd(40);
                  break;
               case 40:
                  if ((0x7e0000007eL & l) == 0L)
                     break;
                  if (kind > 59)
                     kind = 59;
                  jjCheckNAddTwoStates(40, 8);
                  break;
               case 43:
                  if ((0x7fffffe87fffffeL & l) == 0L)
                     break;
                  if (kind > 67)
                     kind = 67;
                  jjCheckNAdd(43);
                  break;
               case 44:
                  if ((0x7fffffe87fffffeL & l) != 0L)
                     jjCheckNAddTwoStates(44, 45);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else
      {
         int hiByte = (int)(curChar >> 8);
         int i1 = hiByte >> 6;
         long l1 = 1L << (hiByte & 077);
         int i2 = (curChar & 0xff) >> 6;
         long l2 = 1L << (curChar & 077);
         do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 67)
                     kind = 67;
                  jjCheckNAddStates(10, 12);
                  break;
               case 1:
                  if (jjCanMove_1(hiByte, i1, i2, l1, l2))
                     jjCheckNAddStates(13, 15);
                  break;
               case 4:
                  if (jjCanMove_1(hiByte, i1, i2, l1, l2))
                     jjCheckNAddStates(21, 23);
                  break;
               case 43:
                  if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 67)
                     kind = 67;
                  jjCheckNAdd(43);
                  break;
               case 44:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(44, 45);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      if (kind != 0x7fffffff)
      {
         jjmatchedKind = kind;
         jjmatchedPos = curPos;
         kind = 0x7fffffff;
      }
      ++curPos;
      if ((i = jjnewStateCnt) == (startsAt = 46 - (jjnewStateCnt = startsAt)))
         break;
      try { curChar = input_stream.readChar(); }
      catch(java.io.IOException e) { break; }
   }
   if (jjmatchedPos > strPos)
      return curPos;

   int toRet = Math.max(curPos, seenUpto);

   if (curPos < toRet)
      for (i = toRet - Math.min(curPos, seenUpto); i-- > 0; )
         try { curChar = input_stream.readChar(); }
         catch(java.io.IOException e) { throw new Error("Internal Error : Please send a bug report."); }

   if (jjmatchedPos < strPos)
   {
      jjmatchedKind = strKind;
      jjmatchedPos = strPos;
   }
   else if (jjmatchedPos == strPos && jjmatchedKind > strKind)
      jjmatchedKind = strKind;

   return toRet;
}
private int jjMoveStringLiteralDfa0_2()
{
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa1_2(0x800L);
      case 66:
         return jjMoveStringLiteralDfa1_2(0x410000L);
      case 67:
         return jjMoveStringLiteralDfa1_2(0x4000000L);
      case 68:
         return jjMoveStringLiteralDfa1_2(0x208000L);
      case 69:
         return jjMoveStringLiteralDfa1_2(0x820000L);
      case 73:
         return jjMoveStringLiteralDfa1_2(0x1000L);
      case 78:
         return jjMoveStringLiteralDfa1_2(0x82000L);
      case 83:
         return jjMoveStringLiteralDfa1_2(0x104000L);
      case 85:
         return jjMoveStringLiteralDfa1_2(0x2000000L);
      case 86:
         return jjMoveStringLiteralDfa1_2(0x1040000L);
      default :
         return 1;
   }
}
private int jjMoveStringLiteralDfa1_2(long active1)
{
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 1;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa2_2(active1, 0x1248000L);
      case 66:
         return jjMoveStringLiteralDfa2_2(active1, 0x800L);
      case 68:
         return jjMoveStringLiteralDfa2_2(active1, 0x1000L);
      case 78:
         return jjMoveStringLiteralDfa2_2(active1, 0x2820000L);
      case 79:
         return jjMoveStringLiteralDfa2_2(active1, 0x4410000L);
      case 84:
         return jjMoveStringLiteralDfa2_2(active1, 0x104000L);
      case 85:
         return jjMoveStringLiteralDfa2_2(active1, 0x82000L);
      default :
         return 2;
   }
}
private int jjMoveStringLiteralDfa2_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 2;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 2;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa3_2(active1, 0x1000L);
      case 75:
         return jjMoveStringLiteralDfa3_2(active1, 0x2000000L);
      case 76:
         return jjMoveStringLiteralDfa3_2(active1, 0x5040000L);
      case 77:
         return jjMoveStringLiteralDfa3_2(active1, 0x82000L);
      case 79:
         return jjMoveStringLiteralDfa3_2(active1, 0x410000L);
      case 82:
         return jjMoveStringLiteralDfa3_2(active1, 0x104000L);
      case 83:
         return jjMoveStringLiteralDfa3_2(active1, 0x800L);
      case 84:
         return jjMoveStringLiteralDfa3_2(active1, 0xa28000L);
      default :
         return 3;
   }
}
private int jjMoveStringLiteralDfa3_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 3;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 3;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa4_2(active1, 0x28a000L);
      case 73:
         return jjMoveStringLiteralDfa4_2(active1, 0x924000L);
      case 76:
         return jjMoveStringLiteralDfa4_2(active1, 0x4410000L);
      case 78:
         return jjMoveStringLiteralDfa4_2(active1, 0x2001000L);
      case 84:
         return jjMoveStringLiteralDfa4_2(active1, 0x800L);
      case 85:
         return jjMoveStringLiteralDfa4_2(active1, 0x1040000L);
      default :
         return 4;
   }
}
private int jjMoveStringLiteralDfa4_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 4;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 4;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa5_2(active1, 0x5450000L);
      case 78:
         return jjMoveStringLiteralDfa5_2(active1, 0x104000L);
      case 79:
         return jjMoveStringLiteralDfa5_2(active1, 0x2000000L);
      case 82:
         return jjMoveStringLiteralDfa5_2(active1, 0x82800L);
      case 84:
         return jjMoveStringLiteralDfa5_2(active1, 0xa29000L);
      default :
         return 5;
   }
}
private int jjMoveStringLiteralDfa5_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 5;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 5;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa6_2(active1, 0x410800L);
      case 67:
         return jjMoveStringLiteralDfa6_2(active1, 0x4000000L);
      case 71:
         return jjMoveStringLiteralDfa6_2(active1, 0x104000L);
      case 73:
         return jjMoveStringLiteralDfa6_2(active1, 0x28b000L);
      case 87:
         return jjMoveStringLiteralDfa6_2(active1, 0x2000000L);
      case 89:
         return jjMoveStringLiteralDfa6_2(active1, 0x820000L);
      case 95:
         return jjMoveStringLiteralDfa6_2(active1, 0x1040000L);
      default :
         return 6;
   }
}
private int jjMoveStringLiteralDfa6_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 6;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 6;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa7_2(active1, 0x10c2800L);
      case 70:
         return jjMoveStringLiteralDfa7_2(active1, 0x1000L);
      case 77:
         return jjMoveStringLiteralDfa7_2(active1, 0x208000L);
      case 78:
         return jjMoveStringLiteralDfa7_2(active1, 0x2410000L);
      case 84:
         return jjMoveStringLiteralDfa7_2(active1, 0x4000000L);
      case 95:
         return jjMoveStringLiteralDfa7_2(active1, 0x924000L);
      default :
         return 7;
   }
}
private int jjMoveStringLiteralDfa7_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 7;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 7;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa8_2(active1, 0x208000L);
      case 73:
         return jjMoveStringLiteralDfa8_2(active1, 0x4001000L);
      case 76:
         return jjMoveStringLiteralDfa8_2(active1, 0x1040000L);
      case 84:
         return jjMoveStringLiteralDfa8_2(active1, 0x800L);
      case 86:
         return jjMoveStringLiteralDfa8_2(active1, 0x924000L);
      case 95:
         return jjMoveStringLiteralDfa8_2(active1, 0x2492000L);
      default :
         return 8;
   }
}
private int jjMoveStringLiteralDfa8_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 8;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 8;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa9_2(active1, 0x1964000L);
      case 67:
         return jjMoveStringLiteralDfa9_2(active1, 0x1000L);
      case 79:
         return jjMoveStringLiteralDfa9_2(active1, 0x4000000L);
      case 80:
         return jjMoveStringLiteralDfa9_2(active1, 0x2000000L);
      case 86:
         return jjMoveStringLiteralDfa9_2(active1, 0x492000L);
      case 95:
         return jjMoveStringLiteralDfa9_2(active1, 0x208800L);
      default :
         return 9;
   }
}
private int jjMoveStringLiteralDfa9_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 9;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 9;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa10_2(active1, 0x2493000L);
      case 76:
         return jjMoveStringLiteralDfa10_2(active1, 0x924000L);
      case 78:
         return jjMoveStringLiteralDfa10_2(active1, 0x4000000L);
      case 83:
         return jjMoveStringLiteralDfa10_2(active1, 0x1040800L);
      case 86:
         return jjMoveStringLiteralDfa10_2(active1, 0x208000L);
      default :
         return 10;
   }
}
private int jjMoveStringLiteralDfa10_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 10;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 10;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa11_2(active1, 0x208000L);
      case 67:
         return jjMoveStringLiteralDfa11_2(active1, 0x800L);
      case 76:
         return jjMoveStringLiteralDfa11_2(active1, 0x492000L);
      case 83:
         return jjMoveStringLiteralDfa11_2(active1, 0x1040000L);
      case 84:
         return jjMoveStringLiteralDfa11_2(active1, 0x2001000L);
      case 85:
         return jjMoveStringLiteralDfa11_2(active1, 0x924000L);
      case 95:
         return jjMoveStringLiteralDfa11_2(active1, 0x4000000L);
      default :
         return 11;
   }
}
private int jjMoveStringLiteralDfa11_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 11;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 11;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa12_2(active1, 0x924000L);
      case 72:
         if ((active1 & 0x2000000L) != 0L)
            return jjStopAtPos(11, 89);
         return jjMoveStringLiteralDfa12_2(active1, 0x800L);
      case 73:
         return jjMoveStringLiteralDfa12_2(active1, 0x1000L);
      case 76:
         return jjMoveStringLiteralDfa12_2(active1, 0x208000L);
      case 85:
         return jjMoveStringLiteralDfa12_2(active1, 0x492000L);
      case 86:
         return jjMoveStringLiteralDfa12_2(active1, 0x4000000L);
      case 95:
         return jjMoveStringLiteralDfa12_2(active1, 0x1040000L);
      default :
         return 12;
   }
}
private int jjMoveStringLiteralDfa12_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 12;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 12;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa13_2(active1, 0x4000000L);
      case 68:
         return jjMoveStringLiteralDfa13_2(active1, 0x924000L);
      case 69:
         return jjMoveStringLiteralDfa13_2(active1, 0x492800L);
      case 79:
         return jjMoveStringLiteralDfa13_2(active1, 0x1000L);
      case 85:
         return jjMoveStringLiteralDfa13_2(active1, 0x208000L);
      case 86:
         return jjMoveStringLiteralDfa13_2(active1, 0x1040000L);
      default :
         return 13;
   }
}
private int jjMoveStringLiteralDfa13_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 13;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 13;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa14_2(active1, 0x1040000L);
      case 68:
         return jjMoveStringLiteralDfa14_2(active1, 0x492000L);
      case 69:
         return jjMoveStringLiteralDfa14_2(active1, 0x208000L);
      case 76:
         return jjMoveStringLiteralDfa14_2(active1, 0x4000000L);
      case 77:
         return jjMoveStringLiteralDfa14_2(active1, 0x800L);
      case 78:
         return jjMoveStringLiteralDfa14_2(active1, 0x1000L);
      case 95:
         return jjMoveStringLiteralDfa14_2(active1, 0x924000L);
      default :
         return 14;
   }
}
private int jjMoveStringLiteralDfa14_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 14;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 14;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa15_2(active1, 0x800L);
      case 68:
         return jjMoveStringLiteralDfa15_2(active1, 0x208000L);
      case 76:
         return jjMoveStringLiteralDfa15_2(active1, 0x1040000L);
      case 80:
         return jjMoveStringLiteralDfa15_2(active1, 0x924000L);
      case 85:
         return jjMoveStringLiteralDfa15_2(active1, 0x4000000L);
      case 95:
         return jjMoveStringLiteralDfa15_2(active1, 0x493000L);
      default :
         return 15;
   }
}
private int jjMoveStringLiteralDfa15_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 15;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 15;
   }
   switch(curChar)
   {
      case 58:
         if ((active1 & 0x800L) != 0L)
            return jjStopAtPos(15, 75);
         break;
      case 65:
         return jjMoveStringLiteralDfa16_2(active1, 0x924000L);
      case 69:
         return jjMoveStringLiteralDfa16_2(active1, 0x4000000L);
      case 80:
         return jjMoveStringLiteralDfa16_2(active1, 0x492000L);
      case 85:
         return jjMoveStringLiteralDfa16_2(active1, 0x1040000L);
      case 86:
         return jjMoveStringLiteralDfa16_2(active1, 0x1000L);
      case 95:
         return jjMoveStringLiteralDfa16_2(active1, 0x208000L);
      default :
         return 16;
   }
   return 16;
}
private int jjMoveStringLiteralDfa16_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 16;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 16;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa17_2(active1, 0x493000L);
      case 68:
         return jjMoveStringLiteralDfa17_2(active1, 0x4000000L);
      case 69:
         return jjMoveStringLiteralDfa17_2(active1, 0x1040000L);
      case 80:
         return jjMoveStringLiteralDfa17_2(active1, 0x208000L);
      case 82:
         return jjMoveStringLiteralDfa17_2(active1, 0x24000L);
      case 84:
         return jjMoveStringLiteralDfa17_2(active1, 0x900000L);
      default :
         return 17;
   }
}
private int jjMoveStringLiteralDfa17_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 17;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 17;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa18_2(active1, 0x22c000L);
      case 68:
         return jjMoveStringLiteralDfa18_2(active1, 0x1040000L);
      case 72:
         if ((active1 & 0x100000L) != 0L)
            return jjStopAtPos(17, 84);
         else if ((active1 & 0x800000L) != 0L)
            return jjStopAtPos(17, 87);
         break;
      case 82:
         return jjMoveStringLiteralDfa18_2(active1, 0x13000L);
      case 84:
         return jjMoveStringLiteralDfa18_2(active1, 0x480000L);
      case 95:
         return jjMoveStringLiteralDfa18_2(active1, 0x4000000L);
      default :
         return 18;
   }
   return 18;
}
private int jjMoveStringLiteralDfa18_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 18;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 18;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa19_2(active1, 0x12000L);
      case 72:
         if ((active1 & 0x80000L) != 0L)
            return jjStopAtPos(18, 83);
         else if ((active1 & 0x400000L) != 0L)
            return jjStopAtPos(18, 86);
         break;
      case 73:
         return jjMoveStringLiteralDfa19_2(active1, 0x1000L);
      case 77:
         return jjMoveStringLiteralDfa19_2(active1, 0x24000L);
      case 80:
         return jjMoveStringLiteralDfa19_2(active1, 0x4000000L);
      case 82:
         return jjMoveStringLiteralDfa19_2(active1, 0x8000L);
      case 84:
         return jjMoveStringLiteralDfa19_2(active1, 0x200000L);
      case 95:
         return jjMoveStringLiteralDfa19_2(active1, 0x1040000L);
      default :
         return 19;
   }
   return 19;
}
private int jjMoveStringLiteralDfa19_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 19;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 19;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa20_2(active1, 0x4009000L);
      case 69:
         return jjMoveStringLiteralDfa20_2(active1, 0x24000L);
      case 72:
         if ((active1 & 0x200000L) != 0L)
            return jjStopAtPos(19, 85);
         break;
      case 77:
         return jjMoveStringLiteralDfa20_2(active1, 0x12000L);
      case 80:
         return jjMoveStringLiteralDfa20_2(active1, 0x1040000L);
      default :
         return 20;
   }
   return 20;
}
private int jjMoveStringLiteralDfa20_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 20;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 20;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa21_2(active1, 0x1040000L);
      case 66:
         return jjMoveStringLiteralDfa21_2(active1, 0x1000L);
      case 69:
         return jjMoveStringLiteralDfa21_2(active1, 0x12000L);
      case 77:
         return jjMoveStringLiteralDfa21_2(active1, 0x8000L);
      case 84:
         return jjMoveStringLiteralDfa21_2(active1, 0x4024000L);
      default :
         return 21;
   }
}
private int jjMoveStringLiteralDfa21_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 21;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 21;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa22_2(active1, 0x2c000L);
      case 72:
         if ((active1 & 0x4000000L) != 0L)
            return jjStopAtPos(21, 90);
         break;
      case 76:
         return jjMoveStringLiteralDfa22_2(active1, 0x1000L);
      case 82:
         return jjMoveStringLiteralDfa22_2(active1, 0x40000L);
      case 84:
         return jjMoveStringLiteralDfa22_2(active1, 0x1012000L);
      default :
         return 22;
   }
   return 22;
}
private int jjMoveStringLiteralDfa22_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 22;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 22;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa23_2(active1, 0x40000L);
      case 69:
         if ((active1 & 0x1000L) != 0L)
            return jjStopAtPos(22, 76);
         return jjMoveStringLiteralDfa23_2(active1, 0x12000L);
      case 72:
         if ((active1 & 0x1000000L) != 0L)
            return jjStopAtPos(22, 88);
         break;
      case 82:
         if ((active1 & 0x4000L) != 0L)
            return jjStopAtPos(22, 78);
         else if ((active1 & 0x20000L) != 0L)
            return jjStopAtPos(22, 81);
         break;
      case 84:
         return jjMoveStringLiteralDfa23_2(active1, 0x8000L);
      default :
         return 23;
   }
   return 23;
}
private int jjMoveStringLiteralDfa23_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 23;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 23;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa24_2(active1, 0x8000L);
      case 77:
         return jjMoveStringLiteralDfa24_2(active1, 0x40000L);
      case 82:
         if ((active1 & 0x2000L) != 0L)
            return jjStopAtPos(23, 77);
         else if ((active1 & 0x10000L) != 0L)
            return jjStopAtPos(23, 80);
         break;
      default :
         return 24;
   }
   return 24;
}
private int jjMoveStringLiteralDfa24_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 24;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 24;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa25_2(active1, 0x40000L);
      case 82:
         if ((active1 & 0x8000L) != 0L)
            return jjStopAtPos(24, 79);
         break;
      default :
         return 25;
   }
   return 25;
}
private int jjMoveStringLiteralDfa25_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 25;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 25;
   }
   switch(curChar)
   {
      case 84:
         return jjMoveStringLiteralDfa26_2(active1, 0x40000L);
      default :
         return 26;
   }
}
private int jjMoveStringLiteralDfa26_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 26;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 26;
   }
   switch(curChar)
   {
      case 69:
         return jjMoveStringLiteralDfa27_2(active1, 0x40000L);
      default :
         return 27;
   }
}
private int jjMoveStringLiteralDfa27_2(long old1, long active1)
{
   if (((active1 &= old1)) == 0L)
      return 27;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      return 27;
   }
   switch(curChar)
   {
      case 82:
         if ((active1 & 0x40000L) != 0L)
            return jjStopAtPos(27, 82);
         break;
      default :
         return 28;
   }
   return 28;
}
static final int[] jjnextStates = {
   1, 2, 3, 24, 25, 30, 31, 34, 35, 14, 43, 44, 45, 1, 3, 5, 
   16, 19, 39, 41, 8, 3, 4, 5, 10, 11, 14, 20, 22, 18, 26, 27, 
   14, 34, 35, 14, 12, 13, 28, 29, 32, 33, 36, 37, 
};
private static final boolean jjCanMove_0(int hiByte, int i1, int i2, long l1, long l2)
{
   switch(hiByte)
   {
      case 0:
         return ((jjbitVec2[i2] & l2) != 0L);
      case 48:
         return ((jjbitVec3[i2] & l2) != 0L);
      case 49:
         return ((jjbitVec4[i2] & l2) != 0L);
      case 51:
         return ((jjbitVec5[i2] & l2) != 0L);
      case 61:
         return ((jjbitVec6[i2] & l2) != 0L);
      default :
         if ((jjbitVec0[i1] & l1) != 0L)
            return true;
         return false;
   }
}
private static final boolean jjCanMove_1(int hiByte, int i1, int i2, long l1, long l2)
{
   switch(hiByte)
   {
      case 0:
         return ((jjbitVec8[i2] & l2) != 0L);
      default :
         if ((jjbitVec7[i1] & l1) != 0L)
            return true;
         return false;
   }
}

/** Token literal values. */
public static final String[] jjstrLiteralImages = {
"", null, null, null, null, null, null, null, null, null, null, null, null, 
null, null, null, null, null, null, null, null, null, null, null, null, null, null, 
null, null, null, null, null, null, null, null, null, null, null, null, null, null, 
null, null, null, "\50", "\51", "\54", "\56", "\76", "\74", "\75", "\74\75", 
"\76\75", "\74\76", "\53", "\55", "\52", "\57", null, null, null, null, null, null, null, 
null, null, null, null, null, null, null, null, null, null, 
"\101\102\123\124\122\101\103\124\137\123\103\110\105\115\101\72", 
"\111\104\105\116\124\111\106\111\103\101\124\111\117\116\137\126\101\122\111\101\102\114\105", 
"\116\125\115\105\122\111\103\137\126\101\114\125\105\104\137\120\101\122\101\115\105\124\105\122", 
"\123\124\122\111\116\107\137\126\101\114\125\105\104\137\120\101\122\101\115\105\124\105\122", 
"\104\101\124\105\124\111\115\105\137\126\101\114\125\105\104\137\120\101\122\101\115\105\124\105\122", 
"\102\117\117\114\105\101\116\137\126\101\114\125\105\104\137\120\101\122\101\115\105\124\105\122", 
"\105\116\124\111\124\131\137\126\101\114\125\105\104\137\120\101\122\101\115\105\124\105\122", 
"\126\101\114\125\105\137\103\114\101\123\123\137\126\101\114\125\105\104\137\120\101\122\101\115\105\124\105\122", 
"\116\125\115\105\122\111\103\137\126\101\114\125\105\104\137\120\101\124\110", "\123\124\122\111\116\107\137\126\101\114\125\105\104\137\120\101\124\110", 
"\104\101\124\105\124\111\115\105\137\126\101\114\125\105\104\137\120\101\124\110", 
"\102\117\117\114\105\101\116\137\126\101\114\125\105\104\137\120\101\124\110", "\105\116\124\111\124\131\137\126\101\114\125\105\104\137\120\101\124\110", 
"\126\101\114\125\105\137\103\114\101\123\123\137\126\101\114\125\105\104\137\120\101\124\110", "\125\116\113\116\117\127\116\137\120\101\124\110", 
"\103\117\114\114\105\103\124\111\117\116\137\126\101\114\125\105\104\137\120\101\124\110", };

/** Lexer state names. */
public static final String[] lexStateNames = {
   "DEFAULT",
   "IN_NAVIGATION",
   "DUMMY",
};

/** Lex State array. */
public static final int[] jjnewLexState = {
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, -1, 0, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
};
static final long[] jjtoToken = {
   0x8fffffffffffffe1L, 0x7fffc8eL, 
};
static final long[] jjtoSkip = {
   0x1eL, 0x300L, 
};
static final long[] jjtoSpecial = {
   0x0L, 0x300L, 
};
protected JavaCharStream input_stream;
private final int[] jjrounds = new int[46];
private final int[] jjstateSet = new int[92];
private final StringBuilder jjimage = new StringBuilder();
private StringBuilder image = jjimage;
private int jjimageLen;
private int lengthOfMatch;
protected char curChar;
/** Constructor. */
public JBossQLParserTokenManager(JavaCharStream stream){
   if (JavaCharStream.staticFlag)
      throw new Error("ERROR: Cannot use a static CharStream class with a non-static lexical analyzer.");
   input_stream = stream;
}

/** Constructor. */
public JBossQLParserTokenManager(JavaCharStream stream, int lexState){
   this(stream);
   SwitchTo(lexState);
}

/** Reinitialise parser. */
public void ReInit(JavaCharStream stream)
{
   jjmatchedPos = jjnewStateCnt = 0;
   curLexState = defaultLexState;
   input_stream = stream;
   ReInitRounds();
}
private void ReInitRounds()
{
   int i;
   jjround = 0x80000001;
   for (i = 46; i-- > 0;)
      jjrounds[i] = 0x80000000;
}

/** Reinitialise parser. */
public void ReInit(JavaCharStream stream, int lexState)
{
   ReInit(stream);
   SwitchTo(lexState);
}

/** Switch to specified lex state. */
public void SwitchTo(int lexState)
{
   if (lexState >= 3 || lexState < 0)
      throw new TokenMgrError("Error: Ignoring invalid lexical state : " + lexState + ". State unchanged.", TokenMgrError.INVALID_LEXICAL_STATE);
   else
      curLexState = lexState;
}

protected Token jjFillToken()
{
   final Token t;
   final String curTokenImage;
   final int beginLine;
   final int endLine;
   final int beginColumn;
   final int endColumn;
   String im = jjstrLiteralImages[jjmatchedKind];
   curTokenImage = (im == null) ? input_stream.GetImage() : im;
   beginLine = input_stream.getBeginLine();
   beginColumn = input_stream.getBeginColumn();
   endLine = input_stream.getEndLine();
   endColumn = input_stream.getEndColumn();
   t = Token.newToken(jjmatchedKind, curTokenImage);

   t.beginLine = beginLine;
   t.endLine = endLine;
   t.beginColumn = beginColumn;
   t.endColumn = endColumn;

   return t;
}

int curLexState = 0;
int defaultLexState = 0;
int jjnewStateCnt;
int jjround;
int jjmatchedPos;
int jjmatchedKind;

/** Get the next Token. */
public Token getNextToken() 
{
  Token specialToken = null;
  Token matchedToken;
  int curPos = 0;

  EOFLoop :
  for (;;)
  {
   try
   {
      curChar = input_stream.BeginToken();
   }
   catch(java.io.IOException e)
   {
      jjmatchedKind = 0;
      matchedToken = jjFillToken();
      matchedToken.specialToken = specialToken;
      return matchedToken;
   }
   image = jjimage;
   image.setLength(0);
   jjimageLen = 0;

   switch(curLexState)
   {
     case 0:
       jjmatchedKind = 0x7fffffff;
       jjmatchedPos = 0;
       curPos = jjMoveStringLiteralDfa0_0();
       break;
     case 1:
       jjmatchedKind = 0x7fffffff;
       jjmatchedPos = 0;
       curPos = jjMoveStringLiteralDfa0_1();
       break;
     case 2:
       jjmatchedKind = 0x7fffffff;
       jjmatchedPos = 0;
       curPos = jjMoveStringLiteralDfa0_2();
       break;
   }
     if (jjmatchedKind != 0x7fffffff)
     {
        if (jjmatchedPos + 1 < curPos)
           input_stream.backup(curPos - jjmatchedPos - 1);
        if ((jjtoToken[jjmatchedKind >> 6] & (1L << (jjmatchedKind & 077))) != 0L)
        {
           matchedToken = jjFillToken();
           matchedToken.specialToken = specialToken;
           TokenLexicalActions(matchedToken);
       if (jjnewLexState[jjmatchedKind] != -1)
         curLexState = jjnewLexState[jjmatchedKind];
           return matchedToken;
        }
        else
        {
           if ((jjtoSpecial[jjmatchedKind >> 6] & (1L << (jjmatchedKind & 077))) != 0L)
           {
              matchedToken = jjFillToken();
              if (specialToken == null)
                 specialToken = matchedToken;
              else
              {
                 matchedToken.specialToken = specialToken;
                 specialToken = (specialToken.next = matchedToken);
              }
              SkipLexicalActions(matchedToken);
           }
           else
              SkipLexicalActions(null);
         if (jjnewLexState[jjmatchedKind] != -1)
           curLexState = jjnewLexState[jjmatchedKind];
           continue EOFLoop;
        }
     }
     int error_line = input_stream.getEndLine();
     int error_column = input_stream.getEndColumn();
     String error_after = null;
     boolean EOFSeen = false;
     try { input_stream.readChar(); input_stream.backup(1); }
     catch (java.io.IOException e1) {
        EOFSeen = true;
        error_after = curPos <= 1 ? "" : input_stream.GetImage();
        if (curChar == '\n' || curChar == '\r') {
           error_line++;
           error_column = 0;
        }
        else
           error_column++;
     }
     if (!EOFSeen) {
        input_stream.backup(1);
        error_after = curPos <= 1 ? "" : input_stream.GetImage();
     }
     throw new TokenMgrError(EOFSeen, curLexState, error_line, error_column, error_after, curChar, TokenMgrError.LEXICAL_ERROR);
  }
}

void SkipLexicalActions(Token matchedToken)
{
   switch(jjmatchedKind)
   {
      case 72 :
         image.append(input_stream.GetSuffix(jjimageLen + (lengthOfMatch = jjmatchedPos + 1)));
      resetPath();
      addPath(matchedToken.image.toLowerCase());
         break;
      case 73 :
         image.append(input_stream.GetSuffix(jjimageLen + (lengthOfMatch = jjmatchedPos + 1)));
                      addPath(matchedToken.image);
         break;
      default :
         break;
   }
}
void TokenLexicalActions(Token matchedToken)
{
   switch(jjmatchedKind)
   {
      case 67 :
        image.append(input_stream.GetSuffix(jjimageLen + (lengthOfMatch = jjmatchedPos + 1)));
      if(catalog.getEntityByAbstractSchemaName(matchedToken.image) != null) {
         matchedToken.kind = ABSTRACT_SCHEMA;
      } else if(idManager.getEntity(matchedToken.image.toLowerCase()) != null) {
         matchedToken.kind = IDENTIFICATION_VARIABLE;
         matchedToken.image = matchedToken.image.toLowerCase();

         List pathList = new ArrayList();
         pathList.add(matchedToken.image);
         List fieldList = new ArrayList();
         fieldList.add(idManager.getEntity(matchedToken.image));
         idManager.registerPath(matchedToken.image, pathList, fieldList);
      }
         break;
      case 71 :
        image.append(input_stream.GetSuffix(jjimageLen + (lengthOfMatch = jjmatchedPos + 1)));
      int n = EJBQLTypes.UNKNOWN_TYPE;
      try {
         n = Integer.parseInt(matchedToken.image.substring(1, lengthOfMatch));
      } catch(Exception e) { /* Should never come here. */ }

      matchedToken.image = "" + n;

      // zero base the index
      n--;

      if(n < argumentTypes.length) {
         switch(EJBQLTypes.getEJBQLType(argumentTypes[n])) {
            case EJBQLTypes.NUMERIC_TYPE:
               matchedToken.kind = NUMERIC_VALUED_PARAMETER;
               break;
            case EJBQLTypes.STRING_TYPE:
               matchedToken.kind = STRING_VALUED_PARAMETER;
               break;
            case EJBQLTypes.DATETIME_TYPE:
               matchedToken.kind = DATETIME_VALUED_PARAMETER;
               break;
            case EJBQLTypes.BOOLEAN_TYPE:
               matchedToken.kind = BOOLEAN_VALUED_PARAMETER;
               break;
            case EJBQLTypes.ENTITY_TYPE:
               matchedToken.kind = ENTITY_VALUED_PARAMETER;
               break;
            case EJBQLTypes.VALUE_CLASS_TYPE:
               matchedToken.kind = VALUE_CLASS_VALUED_PARAMETER;
               break;
         }
      }
         break;
      case 74 :
        image.append(input_stream.GetSuffix(jjimageLen + (lengthOfMatch = jjmatchedPos + 1)));
      String fieldName = matchedToken.image;
      matchedToken.image = path + fieldName;

      FieldBridge field = getCurrentSchema().getFieldByName(fieldName);
      if(field == null) {
         throwUnknownPath("Unknown terminal field", fieldName);
      }
      if(field instanceof CMPFieldBridge) {
         CMPFieldBridge cmpField = (CMPFieldBridge)field;
         switch(EJBQLTypes.getEJBQLType(cmpField.getFieldType())) {
            case EJBQLTypes.NUMERIC_TYPE:
               matchedToken.kind = NUMERIC_VALUED_PATH;
               break;
            case EJBQLTypes.STRING_TYPE:
               matchedToken.kind = STRING_VALUED_PATH;
               break;
            case EJBQLTypes.DATETIME_TYPE:
               matchedToken.kind = DATETIME_VALUED_PATH;
               break;
            case EJBQLTypes.BOOLEAN_TYPE:
               matchedToken.kind = BOOLEAN_VALUED_PATH;
               break;
            case EJBQLTypes.ENTITY_TYPE:
               matchedToken.kind = ENTITY_VALUED_PATH;
               break;
            case EJBQLTypes.VALUE_CLASS_TYPE:
               matchedToken.kind = VALUE_CLASS_VALUED_PATH;
               break;
            default:
               throwUnknownPath("Unknown cmp field type", fieldName);
         }
      } else {
         CMRFieldBridge cmrField = (CMRFieldBridge)field;
         if(cmrField.isSingleValued()) {
            matchedToken.kind = ENTITY_VALUED_PATH;
         } else {
            matchedToken.kind = COLLECTION_VALUED_PATH;
         }
      }
      pathList.add(matchedToken.image);
      fieldList.add(field);
      idManager.registerPath(matchedToken.image, pathList, fieldList);
      resetPath();
         break;
      default :
         break;
   }
}
private void jjCheckNAdd(int state)
{
   if (jjrounds[state] != jjround)
   {
      jjstateSet[jjnewStateCnt++] = state;
      jjrounds[state] = jjround;
   }
}
private void jjAddStates(int start, int end)
{
   do {
      jjstateSet[jjnewStateCnt++] = jjnextStates[start];
   } while (start++ != end);
}
private void jjCheckNAddTwoStates(int state1, int state2)
{
   jjCheckNAdd(state1);
   jjCheckNAdd(state2);
}

private void jjCheckNAddStates(int start, int end)
{
   do {
      jjCheckNAdd(jjnextStates[start]);
   } while (start++ != end);
}

}
